madwifi: add some extra delay between bringing the interface up and configuring it...
[openwrt/openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5 local device="$1"
6 local wds
7 local adhoc sta ap
8
9 config_get vifs "$device" vifs
10 for vif in $vifs; do
11
12 config_get ifname "$vif" ifname
13 config_set "$vif" ifname "${ifname:-ath}"
14
15 config_get mode "$vif" mode
16 case "$mode" in
17 adhoc|ahdemo|sta|ap)
18 append $mode "$vif"
19 ;;
20 wds)
21 config_get addr "$vif" bssid
22 config_get ssid "$vif" ssid
23 [ -z "$addr" -a -n "$ssid" ] && {
24 config_set "$vif" wds 1
25 config_set "$vif" mode sta
26 mode="sta"
27 addr="$ssid"
28 }
29 ${addr:+append $mode "$vif"}
30 ;;
31 *) echo "$device($vif): Invalid mode, ignored."; continue;;
32 esac
33 done
34
35 case "${adhoc:+1}:${sta:+1}:${ap+1}" in
36 # valid mode combinations
37 1::) wds="";;
38 1::1);;
39 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
40 :1:);;
41 ::1);;
42 ::);;
43 *) echo "$device: Invalid mode combination in config"; return 1;;
44 esac
45
46 config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
47 }
48
49
50 disable_atheros() (
51 local device="$1"
52
53 # kill all running hostapd and wpa_supplicant processes that
54 # are running on atheros vifs
55 for pid in `pidof hostapd wpa_supplicant`; do
56 grep ath /proc/$pid/cmdline >/dev/null && \
57 kill $pid
58 done
59
60 include /lib/network
61 cd /proc/sys/net
62 for dev in *; do
63 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
64 ifconfig "$dev" down
65 unbridge "$dev"
66 wlanconfig "$dev" destroy
67 }
68 done
69 return 0
70 )
71
72 enable_atheros() {
73 config_get channel "$device" channel
74 config_get vifs "$device" vifs
75
76 disable_atheros "$device"
77 local first=1
78 for vif in $vifs; do
79 nosbeacon=
80 config_get ifname "$vif" ifname
81 config_get enc "$vif" encryption
82 config_get mode "$vif" mode
83
84 [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
85
86 config_get ifname "$vif" ifname
87 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
88 [ $? -ne 0 ] && {
89 echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
90 continue
91 }
92 config_set "$vif" ifname "$ifname"
93
94 [ "$first" = 1 ] && {
95 # only need to change freq band and channel on the first vif
96 config_get agmode "$device" mode
97 pureg=0
98 case "$agmode" in
99 *b) agmode=11b;;
100 *bg) agmode=11g;;
101 *g) agmode=11g; pureg=1;;
102 *a) agmode=11a;;
103 *) agmode=auto;;
104 esac
105 iwconfig "$ifname" channel 0 >/dev/null 2>/dev/null
106 ifconfig "$ifname" up
107 sleep 1
108 iwpriv "$ifname" mode "$agmode"
109 iwpriv "$ifname" pureg "$pureg"
110 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
111 }
112
113 config_get_bool hidden "$vif" hidden 0
114 iwpriv "$ifname" hide_ssid "$hidden"
115
116 config_get_bool ff "$vif" ff 0
117 iwpriv "$ifname" ff "$ff"
118
119 config_get wds "$vif" wds
120 case "$wds" in
121 1|on|enabled) wds=1;;
122 *) wds=0;;
123 esac
124 iwpriv "$ifname" wds "$wds"
125
126 wpa=
127 case "$enc" in
128 WEP|wep)
129 for idx in 1 2 3 4; do
130 config_get key "$vif" "key${idx}"
131 iwconfig "$ifname" enc "[$idx]" "${key:-off}"
132 done
133 config_get key "$vif" key
134 key="${key:-1}"
135 case "$key" in
136 [1234]) iwconfig "$ifname" enc "[$key]";;
137 *) iwconfig "$ifname" enc "$key";;
138 esac
139 ;;
140 PSK|psk|PSK2|psk2)
141 config_get key "$vif" key
142 ;;
143 esac
144
145 case "$mode" in
146 wds)
147 config_get addr "$vif" bssid
148 iwpriv "$ifname" wds_add "$addr"
149 ;;
150 adhoc|ahdemo)
151 config_get addr "$vif" bssid
152 [ -z "$addr" ] || {
153 iwconfig "$ifname" ap "$addr"
154 }
155 ;;
156 esac
157 config_get ssid "$vif" ssid
158
159 [ "$mode" = "sta" ] && {
160 config_get_bool bgscan "$vif" bgscan 1
161 iwpriv "$ifname" bgscan "$bgscan"
162 }
163
164 config_get_bool antdiv "$device" diversity 1
165 sysctl -w dev."$device".diversity="$antdiv" >&-
166
167 config_get antrx "$device" rxantenna
168 if [ -n "$antrx" ]; then
169 sysctl -w dev."$device".rxantenna="$antrx" >&-
170 fi
171
172 config_get anttx "$device" txantenna
173 if [ -n "$anttx" ]; then
174 sysctl -w dev."$device".txantenna="$anttx" >&-
175 fi
176
177 config_get distance "$device" distance
178 if [ -n "$distance" ]; then
179 athctrl -i "$device" -d "$distance" >&-
180 fi
181
182 config_get txpwr "$vif" txpower
183 if [ -n "$txpwr" ]; then
184 iwconfig "$ifname" txpower "${txpwr%%.*}"
185 fi
186
187 ifconfig "$ifname" up
188 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
189
190 local net_cfg bridge
191 net_cfg="$(find_net_config "$vif")"
192 [ -z "$net_cfg" ] || {
193 bridge="$(bridge_interface "$net_cfg")"
194 config_set "$vif" bridge "$bridge"
195 start_net "$ifname" "$net_cfg"
196 }
197 iwconfig "$ifname" essid "$ssid"
198 case "$mode" in
199 ap)
200 config_get_bool isolate "$vif" isolate 0
201 iwpriv "$ifname" ap_bridge "$((isolate^1))"
202
203 if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
204 hostapd_setup_vif "$vif" madwifi || {
205 echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
206 # make sure this wifi interface won't accidentally stay open without encryption
207 ifconfig "$ifname" down
208 wlanconfig "$ifname" destroy
209 continue
210 }
211 fi
212 ;;
213 wds|sta)
214 case "$enc" in
215 PSK|psk|PSK2|psk2)
216 case "$enc" in
217 PSK|psk)
218 proto='proto=WPA';;
219 PSK2|psk2)
220 proto='proto=RSN';;
221 esac
222 cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
223 ctrl_interface=/var/run/wpa_supplicant
224 network={
225 scan_ssid=1
226 ssid="$ssid"
227 key_mgmt=WPA-PSK
228 $proto
229 psk="$key"
230 }
231 EOF
232 ;;
233 WPA|wpa|WPA2|wpa2)
234 #add wpa_supplicant calls here
235 ;;
236 esac
237 [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -Bw -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
238 ;;
239 esac
240 first=0
241 done
242 }
243
244
245 detect_atheros() {
246 cd /proc/sys/dev
247 [ -d ath ] || return
248 for dev in $(ls -d wifi* 2>&-); do
249 config_get type "$dev" type
250 [ "$type" = atheros ] && return
251 cat <<EOF
252 config wifi-device $dev
253 option type atheros
254 option channel 5
255 # option diversity 1
256 # option txantenna 0
257 # option rxantenna 0
258 # option distance 2000
259 # disable radio to prevent an open ap after reflashing:
260 option disabled 1
261
262
263 config wifi-iface
264 option device $dev
265 option network lan
266 option mode ap
267 option ssid OpenWrt
268 option hidden 0
269 # option txpower 15
270 # option bgscan enable
271 option encryption none
272
273 EOF
274 done
275 }